<template>
  <div class="roles">
    <div class="brea-wrp">
      <el-breadcrumb separator-class="el-icon-arrow-right">
        <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>权限管理</el-breadcrumb-item>
        <el-breadcrumb-item>角色列表</el-breadcrumb-item>
      </el-breadcrumb>
    </div>
    <el-button
      type="primary"
      size="mini"
      icon="el-icon-plus"
      @click="rolesDialogStatus=true"
      style="margin-bottom:20px;"
    >添加角色</el-button>

    <el-table :data="roleList" style="width:100%">
      <el-table-column type="expand">
        <template slot-scope="scope">
          <el-row v-for="item in scope.row.children" :key="item.id">
            <el-col :span="5">
              <el-tag closable @close="_deleteRights(scope.row.id,item.id)">{{item.authName}}</el-tag>
              <i class="el-icon-arrow-right"></i>
            </el-col>
            <el-col :span="19">
              <el-row v-for="_item in item.children" :key="_item.id">
                <el-col :span="8">
                  <el-tag @close="_deleteRights(scope.row.id,_item.id)" closable>{{_item.authName}}</el-tag>
                  <i class="el-icon-arrow-right"></i>
                </el-col>
                <el-col :span="16">
                  <el-tag
                    @close="_deleteRights(scope.row.id,__item.id)"
                    v-for="__item in _item.children"
                    :key="__item.id"
                    closable
                  >{{__item.authName}}</el-tag>
                </el-col>
              </el-row>
            </el-col>
          </el-row>
        </template>
      </el-table-column>
      <el-table-column type="index" width="50"></el-table-column>
      <el-table-column prop="roleName" label="角色名称" width="180"></el-table-column>
      <el-table-column prop="roleDesc" label="角色描述" width="180"></el-table-column>
      <el-table-column label="操作">
        <template slot-scope="scope">
          <el-button
            type="primary"
            icon="el-icon-edit"
            circle
            size="mini"
            @click="_addRoles(scope.row)"
          ></el-button>
          <el-button
            type="danger"
            icon="el-icon-delete"
            circle
            size="mini"
            @click="_addRoles(scope.row)"
          ></el-button>
          <el-button
            type="success"
            icon="el-icon-check"
            circle
            size="mini"
            @click="openEditDialog(scope.row) "
          ></el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-dialog title="添加角色" :visible.sync="rolesDialogStatus" width="600px">
      <el-form
        :model="roleForm"
        :data="roleForm"
        ref="form"
        label-position="right"
        :rules="rules"
        label-width="80px"
      >
        <el-form-item label="角色名称" prop="roleName">
          <el-input v-model="roleForm.roleName"></el-input>
        </el-form-item>
        <el-form-item label="角色描述" prop="roleDesc">
          <el-input v-model="roleForm.roleDesc"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="rolesDialogStatus = false">取 消</el-button>
        <el-button type="primary" @click="_addRoles">确 定</el-button>
      </div>
    </el-dialog>

    <el-dialog title="修改权限" :visible.sync="editRolesDialogStatus" width="600px">
      <el-tree
        :data="rolesdata"
        show-checkbox
        node-key="id"
        :default-expand-all="true"
        :default-expanded-keys="[2, 3]"
        :default-checked-keys="[5]"
        :props="defaultProps"
        ref="tree"
      ></el-tree>
      <div slot="footer" class="dialog-footer">
        <el-button @click="editRolesDialogStatus = false">取 消</el-button>
        <el-button type="primary" @click="_deitRights(rids)">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { getRolesList, deleteRights, addRoles, gain,editRights } from "@/http/api";
export default {
  data() {
    function validate(rule, value, callback) {
      if (value == 123) {
        callback(new Error("不能是123"));
      } else {
        callback();
      }
    }
    return {
      roleList: [],
      rolesDialogStatus: false,
      dialogVisible: false,
      roleForm: {
        roleName: "",
        roleDesc: ""
      },
      rules: {
        roleName: [
          {
            required: true,
            message: "不能为空",
            trigger: "blur"
          },
          {
            validator: validate,
            trigger: "blur"
          }
        ]
      },
      editRolesDialogStatus: false,
      rolesdata: [],
      defaultProps: {
        children: "children",
        label: "authName"
      }
    };
  },
  methods: {
    _getRolesList() {
      getRolesList().then(res => {
        this.roleList = res.data;
      });
    },
    //删除权限
    _deleteRights(rightId, roleId) {
      deleteRights(rightId, roleId).then(res => {
        this._getRolesList();
      });
    },
    //点击弹出来框框

    //添加角色
    _addRoles() {
      this.$refs.form.validate(validate => {
        if (validate) {
          addRoles(this.roleForm).then(res => {
            this.$message({
              type: "success",
              message: "添加成功"
            });
            this.rolesDialogStatus = false;
            this.$refs.form.resetFields();
            this._getRolesList();
          });
        }
      });
    },
    //获取权限
    openEditDialog(val) {
      let arr = val.children;
      console.log(arr)
      this.editRolesDialogStatus = true;
      gain().then(res => {
        this.rolesdata = res.data;
        this.$nextTick(() => {
          this.$refs.tree.setCheckedNodes(arr);
        });
      });
    },
    //修改权限
    _deitRights(val){
      let rids= this.$refs.tree.getCheckedKeys().join(",")
       this.editRolesDialogStatus =false;
      console.log(this.$refs.tree.getCheckedKeys())
      console.log(rids)
      rids.slice()
       this._getRolesList();
    }
  },
  created() {
    this._getRolesList();
  }
};
</script>

<style scoped>
.roles {
  padding: 15px;
  border-radius: 10px;
}
.brea-wrp {
  margin-bottom: 20px;
}
</style>